
/*   This is an enhanced version of the program discussed in RobotBASIC Projects for Beginners
     Study the original version first, then examine the new features found in this program.
                        3-D effects require Crayola 3-D glasses
*/
MainProgram:
  gosub Initialization
  while True
    ReadMouse a,b,c
    if a<125
      gosub ProcessMenu
    else
      gosub DrawBrush
    endif
  wend
end

Initialization:
  OrgFile="" // current file being used
  // init colors
  ClearScr
  co = 0
  br = 2
  bc = 9
  ClearScr bc
  Data R; 255,255,255,230,128,128,  0,  0, 50, 50
  Data G;   0,128,255,220,255,128,128, 75,  0,  0
  Data B;   0,  0,  0,200,  0,  0,  0,150,100, 50
  Dim Col[10]
  for i=0 to 9
    Col[i]=rgb(R[i],G[i],B[i])
  next
  
  SetColor Col[8]
  Rectangle 0,0,800,160,Col[8],Col[8]
  Rectangle 10,10,790,150,Col[7],Col[7]
  s = "RobotBASIC 3-D PAINT PROGRAM" \ fnt = "Times New Roman"
  xyText 45,50,s,fnt,30,fs_Bold,,Col[7] 
  OverlayText 65,65,s,fnt,30,fs_bold,Red,false
  linewidth 10
  rectangle 5,150,795,595,Col[8],white
  
  xyString 45,180, "The standard 2-D version of this program was originally written for the book"
  xyText 185,200,"RobotBASIC Projects for Beginners",fnt,20
  xyString 215,230,"by John Blankenship and Samuel Mishal"
  xyString 180,250,"Visit www.RobotBASIC.com for more information."
  xyText 20,275,"INSTRUCTIONS:",fnt,14
  xyString 60,300,"Images will appear in 3-D when using Crayola Prismatic Glasses"
  xyString 60,320,"Colors at the top of the MENU Palette will appear closest to you."
  xyString 60,340,"3-D effect is enhanced when upper colors in Palette are drawn OVER lower colors."
  xyString 60,360,"Choose colors, brush-styles, etc. from MENU by left-clicking item with mouse."
  xyString 60,380,"Current brush and color are shown in the bottom left corner of Menu."
  xyString 60,400,"Hold down left mouse-button to draw."
  xyString 60,420,"Right-click any MENU Palette color to redefine it."
  xyString 60,440,"Choose FILL to fill an area with current color - then click area to fill."
  xyString 60,460,"Right-click OPEN brushes to make the current color the new background color."
  linewidth 1
  for b=0 to 8
    circle 40,305+b*20,44,310+b*20
  next
  AddButton " CONTINUE ",340,510
  repeat
    GetButton b
  until b=" CONTINUE "
  removeButton " CONTINUE "
  ClearScr Col[9] 
  gosub DrawMenu
return

DrawMenu:
  LineWidth 3
  SetColor Black
  c=0
  for i=0 to 540 step 60
    Rectangle 1,i,65,i+60,black,white
    Rectangle 65,i,125,i+60,black,Col[c]
    c=c+1
  next
  xyString 15,20,"OPEN"
  xyString 15,80,"SAVE"
  xyString 13,130,"FILL"
  xyString 8,190,"CLEAR"
  xyString 9,542,"BRUSH"
  s=2
  x=32
  y=270
  circle x-s,y-s,x+s,y+s,black,black
  s=6
  y=330
  circle x-s,y-s,x+s,y+s,black,black
  s=12
  y=390
  circle x-s,y-s,x+s,y+s,black,black 
  s=6
  y=450
  circle x-s,y-s,x+s,y+s,black,white
  s=12
  y=510
  circle x-s,y-s,x+s,y+s,black,white
  gosub Now
return

DrawBrush:
  // assumes br defines the brush and
  // co is the color
  // a,b,c are the mouse data
  while c=1
    if a>125
      if br<20
        s=br
        Circle a-s,b-s,a+s,b+s,Col[co],Col[co]
      else
        s=(br-20)
        Circle a-s,b-s,a+s,b+s,Col[co],Col[bc]
      endif
    endif
    ReadMouse a,b,c
  wend
return

ProcessMenu:
  ReadMouse a,b,c
  if a>125 or c=0 then return
  if within(a,60,125)
     // process color
     if c=1
       co = b/60
     elseif c=2
       Col[b/60]=PromptColor(Col[b/60])
       co=b/60
       gosub DrawMenu
     endif
  else
     if c=1
     // other menu item
       if within(b,240,300) then br=2
       if within(b,300,360) then br=6
       if within(b,360,420) then br=12
       if within(b,420,480) then br=26
       if within(b,480,540) then br=32
       if within(b,180,240)
         bc = co
         clearscr Col[bc]
         gosub DrawMenu
       endif
       if within(b,120,180)
         SetCursor -3
         repeat
           ReadMouse a,b,c
         until c=0
         repeat
           ReadMouse a,b,c
         until c=1
         if a>125 then FloodFill a,b,Col[co]
         SetCursor
       endif
       if within(b,0,60)
          tf = PromptBMP()
          if tf != "" 
            OrgFile = tf
            ReadScr(OrgFile)
          endif 
       gosub DrawMenu
       endif
       if within(b,60,120)
          tf = FileSave(OrgFile)
          if tf != "" 
            OrgFile = tf
            WriteScr(OrgFile)
          endif 
          //Input "SAVING: Enter a File Name",fname
          //if fname<>"" then WriteScr(fname)
       endif
    elseif c=2
       // an open brush was right-clicked
       if within(b,420,540)
          // set the new background color
          bc = co
          // then set the new brush style
          if within(b,420,480) 
            br=26
          else 
            br=32
          endif
          gosub DrawMenu
       endif
    endif
  endif
  gosub Now
return


Now:
  Rectangle 10,150,55,170,Col[co],Col[co]
  Rectangle 10,210,55,230,Col[co],Col[co]
  a=32
  b=577
  s=12
  Circle a-s,b-s,a+s,b+s,white,white
  if br<20
    s=br
    Circle a-s,b-s,a+s,b+s,Col[co],Col[co]
  else
    s=(br-20)
    circle a-s,b-s,a+s,b+s,Col[co],Col[bc]
  endif  
return